<?php

namespace EWR\Discord\Admin\Controller;

use XF\Mvc\ParameterBag;

class Log extends XFCP_Log
{
	public function actionDiscord()
	{
		$this->setSectionContext('discordLog');

		$page = $this->filterPage();
		$perPage = 20;
		
		$logRepo = $this->repository('EWR\Discord:Log');
		$logFinder = $logRepo->findLogs()->limitByPage($page, $perPage);
		
		if ($username = $this->filter('username', 'str'))
		{
			$limitUser = $this->em()->findOne('XF:User', ['username' => $username]);
			if (!$limitUser)
			{
				return $this->error(\XF::phrase('requested_user_not_found'));
			}
		}
		else if ($userId = $this->filter('user_id', 'uint'))
		{
			$limitUser = $this->em()->find('XF:User', $userId);
			if (!$limitUser)
			{
				return $this->error(\XF::phrase('requested_user_not_found'));
			}
		}
		else
		{
			$limitUser = null;
		}
		
		$linkFilters = [];
		if ($limitUser)
		{
			$linkFilters['user_id'] = $limitUser->user_id;
			$logFinder->where('user_id', $limitUser->user_id);
		}
		
		$logs = $logFinder->fetch();

		$viewParams = [
			'logsGrouped' => $logRepo->groupLogs($logs),
			'totalLogs' => count($logs),
			'limitUser' => $limitUser,

			'page' => $page,
			'perPage' => $perPage,
			'total' => $logFinder->total(),
			'linkFilters' => $linkFilters
		];
		return $this->view('EWR:Discord\Logs', 'EWRdiscord_logs', $viewParams);
	}
}