<?php

namespace EWR\Discord\Entity;

use XF\Mvc\Entity\Structure;

class Log extends \XF\Mvc\Entity\Entity
{
	public function getTitle()
	{
		return \XF::phrase('EWRdiscord_'.$this->log_type);
	}
	
	protected function _preSave()
	{
		if (!$this->log_date)
		{
			$this->log_date = \XF::$time;
		}
	}
	public static function getStructure(Structure $structure)
	{
		$structure->table = 'ewr_discord_logs';
		$structure->shortName = 'EWR\Discord:Log';
		$structure->primaryKey = 'log_id';
		$structure->columns = [
			'user_id'				=> ['type' => self::UINT, 'required' => true],
			'log_id'				=> ['type' => self::UINT, 'autoIncrement' => true],
			'log_date'				=> ['type' => self::UINT, 'required' => true],
			'log_type'				=> ['type' => self::STR, 'required' => true],
			'log_old'				=> ['type' => self::STR, 'required' => false, 'default' => ''],
			'log_new'				=> ['type' => self::STR, 'required' => false, 'default' => ''],
		];
		$structure->getters = [
			'title' => true,
		];
		$structure->relations = [];

		return $structure;
	}
}