<?php

namespace EWR\Discord\Entity;

use XF\Mvc\Entity\Structure;

class PortaArticle extends XFCP_PortaArticle
{
	protected function _postSave()
	{
		$parent = parent::_postSave();
		
		if ($this->isInsert())
		{
			if (!empty(\XF::options()->EWRdiscord_channels['ewrporta']))
			{
				$channel = \XF::options()->EWRdiscord_channels['ewrporta'];
				$url = \XF::app()->router('public')->buildLink('canonical:threads', $this->Thread);
				$length = \XF::options()->EWRdiscord_payload;
				
				$data = [
					'content' => \XF::phrase('EWRdiscord_x_posted_new_article_y', [
							'user' => $this->Thread->username,
							'title' => str_replace('@', '@𝅳', $this->article_title ?: $this->Thread->title),
							'url' => $url
						])->render('raw'),
					'embed' => [
						'title' => $this->article_title ?: $this->Thread->title,
						'description' => str_replace('@', '@𝅳',
							htmlspecialchars_decode(\XF::app()->stringFormatter()->snippetString(
								$this->article_excerpt ?: $this->Thread->FirstPost->message, $length,
								['stripBbCode' => true]))),
						'url' => $url,
						'author' => [
							'name' => $this->Thread->User ? $this->Thread->User->username : $this->Thread->username,
							'url' => $this->Thread->User ? \XF::app()->router('public')->buildLink('canonical:members', $this->Thread->User) : '',
							'icon_url' => $this->Thread->User ? $this->Thread->User->getAvatarUrl('s', null, true) : '',
						],
					],
				];
				
				switch ($this->article_icon['type'])
				{
					case 'medio':
						$medio = $this->finder('EWR\Medio:Media')->where('media_id', $this->article_icon['data'])->fetchOne();
						$data['embed']['image']['url'] = $medio['image'];
						break;
					case 'attach':
						$attach = $this->finder('XF:Attachment')->where('attachment_id', $this->article_icon['data'])->fetchOne();
						$data['embed']['image']['url'] = \XF::app()->router('public')->buildLink('canonical:ewr-porta/attachments', $attach);
						break;
					case 'image':
						$data['embed']['image']['url'] = $this->article_icon['data'];
						break;
				}
				
				$this->repository('EWR\Discord:Discord')->postToChannel($channel, $data);
			}
		}
		
		return $parent;
	}
}