<?php

namespace EWR\Discord\Pub\Controller;

use XF\Mvc\ParameterBag;

class Account extends XFCP_Account
{
	protected function preferencesSaveProcess(\XF\Entity\User $visitor)
	{
		$reply = parent::preferencesSaveProcess($visitor);
		
		$options = $this->filter([
			'ewr_discord_options' => [
				'crate' => 'bool',
				'count' => 'bool',
				'toast' => 'bool',
				'alert' => 'bool',
			],
		]);
		
		foreach ($options['ewr_discord_options'] AS &$option)
		{
			$option = !$option;
		}
		
		$userOptions = $visitor->getRelationOrDefault('Option');
		$userOptions->ewr_discord_options = $options['ewr_discord_options'];
		$userOptions->save();
		
		return $reply;
	}
	
	public function actionConnectedAccountDisassociate(ParameterBag $params)
	{
		$reply = parent::actionConnectedAccountDisassociate($params);
		
		if ($params->provider_id == 'ewr_discord')
		{
			$visitor = \XF::visitor();
			$connectedAccounts = $visitor->ConnectedAccounts;
			$connectedAccount = $connectedAccounts['ewr_discord'] ?? null;
			
			if ($this->filter('disassociate', 'bool') && !$connectedAccount)
			{
				$this->repository('XF:ConnectedAccount')->rebuildUserConnectedAccountCache($visitor);
			}
		}
		
		return $reply;
	}
}